/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SETOR                                                    */
/* Tabela : SETOR                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SETOR
BEFORE INSERT OR UPDATE OR DELETE
ON SETOR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSETO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSETOR,0) <> NVL(:NEW.CDSETOR,0)) OR
         (NVL(:OLD.SGSETOR,0) <> NVL(:NEW.SGSETOR,0)) OR
         (NVL(:OLD.NMSETOR,0) <> NVL(:NEW.NMSETOR,0)) THEN
         :NEW.DTULTATUSETO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SETOR', '', 'CDSETOR='||:OLD.CDSETOR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SETOR MODIFY DTULTATUSETO DEFAULT SYSDATE
/
