/* Sistemas Integrados TECNISA

Nome: 02CR_GERTRGO_LOG_CDP_PRODACABADO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   27/04/2005 - Joo Paulo
*/


/* Tabela PRODACABADO: Produto Acabado*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir da alterao
              do campo NRLANCESTQ da tabela PRODACABADO*/
/* Objetivo: Gerar um log que indique quando foi efetuado o fechamento da OP parcial*/

CREATE OR REPLACE TRIGGER LOG_CDP_PRODACABADO
AFTER UPDATE OF NRLANCESTQ
ON PRODACABADO FOR EACH ROW
DECLARE
  V_USUARIO         VARCHAR2(40);
  V_TIPO            VARCHAR2(1);
  V_ITPESQ          VARCHAR2(400);
  V_DESC            VARCHAR2(300);
  V_CDFILLOGOPER    VARCHAR2(4);
  V_DTOPER          DATE;
  V_CDARVPROD       VARCHAR2(50);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '2';
   V_ITPESQ  :=  :OLD.CDFILIAL     || :OLD.NRORDPROD    || :OLD.NRSUBORDPROD ||
                 :OLD.CDSUBPRODETA || :OLD.NRSUBPRETAOP || :OLD.CDPRODUTO    ||
                 :OLD.NRPRODACAB;
   V_CDFILLOGOPER := :OLD.CDFILIAL;

   SELECT CDARVPROD INTO V_CDARVPROD
   FROM PRODUTO
   WHERE CDPRODUTO = :OLD.CDPRODUTO;

   V_DESC   := 'Filial='   || :NEW.CDFILIAL    || ' ' ||
               'OP='       || :NEW.NRORDPROD   || ' ' ||
               'SubOP='    || :NEW.NRSUBORDPROD|| ' ' ||
               'Prod='     || V_CDARVPROD      || ' ' ||
               'QtdeProd=' || :NEW.QTPRACABADO || ' ' ||
               'CustoUnit='|| :NEW.VRPRACABADO || ' ' ||
               'Lote='     || :NEW.NRLOTEESTQ  || ' ' ||
               'LancEst='  || :NEW.NRLANCESTQ;

   NMUSUARIO(V_USUARIO);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   V_DTOPER := SYSDATE;
   INSERT INTO LOGOPERA
      (NMTABELA,   DTOPERACAO, NMRESPOPER,
       IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
       DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
   VALUES
       ('PRODACABADO',  V_DTOPER, V_USUARIO,
        V_TIPO,  SUBSTR(V_ITPESQ,1,39), V_DESC, V_CDFILLOGOPER,
        V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_PRODACABADO','5.20.000'); END;
/
